package com.hammingweight.hammock;

import junit.framework.TestCase;

import org.easymock.classextension.EasyMock;

public class AMockObjectTest extends TestCase {

	// You can't set null as the method handler for a test double.
	public void testSetHandlerNullNotAllowed() {
		MockObject mo = new MockObject();
		try {
			mo.setInvocationHandler(null);
			fail();
		} catch (NullPointerException npe) {

		}
	}

	// A simple test of the getter method. Probably don't really need this test.
	public void testGetHandlerOk() {
		IInvocationHandler handler = (IInvocationHandler) EasyMock
				.createMock(IInvocationHandler.class);
		MockObject mo = new MockObject();
		mo.setInvocationHandler(handler);
		assertEquals(handler, mo.getInvocationHandler());
	}

	// We should throw an exception if the method handler is asked for and
	// hasn't been set.
	// This would probably correspond to a user creating a mock object but
	// forgetting to specify a method handler.
	public void testGetHandlerMotOk() {
		MockObject mo = new MockObject();
		try {
			mo.getInvocationHandler();
			fail();
		} catch (HammockException he) {
			assertEquals(IHammockExceptionErrors.HANDLER_NOT_SET, he.getError());
		}
	}

	// We need to test methods in the abstract AMockObject class.
	private static class MockObject extends AMockObject {

	}
}
